## goo 0.155+ds

=== c/g2c/Makefile ===
C_OBJS_DD = $(patsubst %,../%,$(C_OBJS))
.c.o: ../grt.h
	$(CC) -I.. $(CFLAGS) -DDEFAULT_GOO_ROOT=\"$(GOO_ROOT)\" -c -o $@ $<

OBJS = \
	goo/cols/opts.o \
	goo/chr.o \
	goo/io/write.o \
	time/event.o \
	time/%event.o \
	goo/cols/cycle.o \
	time/threads.o \
	time/%threads.o \
	goo/cols/seq.o \
	eval/g2c.o \
	goo/math.o \
	goo/%math.o \
	eval/ast-linearize.o \
	goo/cols/zip.o \
	eval/ast-eval.o \
	eval/dependency.o \
	goo.o \
	goo/cols/step.o \
	time/lock.o \
	time/%lock.o \
	eval/optimize.o \
	goo/eval.o \
	eval/syntax.o \
	goo/cols/colx.o \
	eval/ast.o \
	goo/macros.o \
	goo/io/read.o \
	goo/cols.o \
	goo/system.o \
	goo/%system.o \
	goo/sym.o \
	goo/cols/seqx.o \
	goo/types.o \
	goo/fun.o \
	goo/any.o \
	goo/cols/range.o \
	goo/boot.o \
	goo/mag.o \
	goo/conditions.o \
	goo/loc.o \
	goo/cols/rep.o \
	goo/cols/flat.o \
	goo/cols/map.o \
	eval/main.o \
	goo/random.o \
	goo/io/port.o \
	goo/io/%port.o \
	goo/user.o \
	goo/cols/lst.o \
	eval/module.o \
	goo/cols/col.o \
	goo/cols/tab.o \
	goo/packer.o \
	goo/x.o \
	goo/functional.o \
	goo/bignum.o \
	goo/cols/vec.o \
	goo/late-macros.o \
	goo/class.o \
	goo/cols/str.o \
	goo/cols/tup.o \
	goo/app.o \
	goo/log.o \
	eval/top.o \
	g2c-init.o

g2c: $(C_OBJS_DD) $(OBJS)
	$(CC) $(LDFLAGS) -o g2c $(C_OBJS_DD) $(OBJS) $(LIBS) -lgmp

clean:
	rm -f g2c $(OBJS)

## goo 0.155

=== debian/changelog ===
goo (0.155-17) unstable; urgency=medium

  * debian/copyright:
    - Fix typo in src/samurui/treegoo.* license -- LGPL-2+, not GPL-2+.
      (Closes: #919988.)
    - Belatedly update years for debian/*.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 24 Jan 2019 22:18:42 -0500

goo (0.155-16) unstable; urgency=medium

  * Split Emacs support into a separate package, now using dh-elpa.
    - debian/.gitignore: Add elpa-goo; generalize goo.foo patterns to
      cover elpa-goo.foo too (conveniently also matching .debhelper).
    - debian/control: Build-depend on dh-elpa; add an elpa-goo binary
      package, and have the main goo package suggest it.
    - debian/elpa-goo.elpa: List elisp files to install; exclude
      goo-font-lock.el (whose autoloads shadow stock font-lock.el), and
      add debian/goo-pkg.el.
    - debian/goo-pkg.el: Characterize metadata; take the *.goo file
      association over from the old emacsen-startup file.
    - debian/goo.emacsen-*: Remove, no longer needed by any name.
    - debian/goo.install: Remove, superseded by elpa-goo.elpa.
    - debian/goo.maintscript: Clean up old emacsen-startup file.
    - debian/rules: Run dh --with elpa.
  * configure: Hand-edit to ignore --runstatedir=*, which debhelper injects
    as of compat level 11.  (Hold off on regeneration with modern Autoconf.)
  * debian/compat: Advance to 11 (from 9).
  * debian/control:
    - Advance debhelper version requirement to 11~ accordingly.
    - Rules-Requires-Root: no (safe with override_dh_auto_install fixed).
    - Repoint Vcs-{Browser,Git} at salsa.
    - Split out Build-Depends-Arch (lib*-dev) and -Indep (dh-elpa).
    - Standards-Version: 4.3.0 (compliant at this point).
  * debian/goo.manpages: New, to avoid needing override_dh_installman.
  * debian/rules:
    - Run dh --without autoreconf, at least for now.
    - override_dh_auto_install: Don't micromanage /usr/bin/goo's ownership
      or permissions; they both come out correct by default, and trying to
      specify ownership explicitly fails without (fake)root.
    - Streamline builds that cover only architecture-dependent or
      -independent binary packages.
      + Limit use of --with elpa to binary and binary-indep.
      + Tag override_dh_auto_{configure,build,install} rules with -arch,
        and add no-op -indep variants.
      + Retire override_dh_installman in favor of debian/goo.manpages,
        to ensure elpa-goo doesn't try to ship goo.1.
      + Make override_dh_elpa_test a no-op for now to work around
        libdebian-source-perl bug #919964.
    - Install txt/changes.txt as NEWS(.gz) rather than changelog(.gz).

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 20 Jan 2019 22:47:51 -0500

goo (0.155-15) unstable; urgency=medium

  * debian/control:
    - Canonicalize with the help of cme fix.  In particular, declare
      Standards-Version: 3.9.8 (already compliant, not that cme checked).
    - Homepage: https://people.csail.mit.edu/jrb/goo/.  (Closes: #767852.)
  * Incorporate (and unignore) automatic patches per dgit.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 24 Jan 2017 23:54:42 -0500

goo (0.155-14) unstable; urgency=medium

  * d/control: Depend on emacsen-common (>= 2.0.8), per the new emacsen policy.
  * d/goo.emacsen-compat: Declare compliance with modern policy (already
    partially adopted by accident, because Debhelper jumped the gun).

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 17 Jun 2014 10:58:39 -0400

goo (0.155-13) unstable; urgency=high

  * debian/goo.emacsen-install: Tolerate preexisting .el symlinks, which
    can exist when configuring goo and an emacs flavor in the same run.
    (Closes: #730811.)
  * debian/control: Note compliance with Standards-Version 3.9.5.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 01 Dec 2013 13:57:57 -0500

goo (0.155-12) unstable; urgency=low

  * src/goo/system.goo (add-tmp-path): make sure to pass
    %create-temp-directory's result through %sb.  (Already taken care of
    in system.c, hand-patched because regeneration shuffles everything,
    but accidentally left out of system.goo.)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 30 Jun 2012 00:11:26 -0400

goo (0.155-11) unstable; urgency=low

  * c/grt.h:
    - Make sure to declare YevalSast_evalYPbinding_{boundQ,value_or}
      to keep dynamically loaded g2c extensions from crashing when taking
      full advantage of 64-bit address spaces, as with PIE on amd64.
    - Also declare the new YgooSsystemYPcreate_temp_directory function.
  * {c/g2c,src}/goo/(%)system.*: arrange to build g2c extensions in secure
    temporary directories (cleaned on exit) rather than directly in /tmp.
  * debian/compat: advance to Debhelper 9.
  * debian/control:
    - Build-Depends: debhelper (>= 9), implying a new enough dpkg-dev.
    - Standards-Version: 3.9.3 (no changes required).
    - Repoint Vcs-* fields at anonscm.debian.org (vs. git.debian.org).
  * debian/goo.emacsen-install: symlink elisp source rather than copying
    it; keep the symlinks around.
  * debian/rules: enable full hardening.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 29 Jun 2012 00:28:41 -0400

goo (0.155-10) unstable; urgency=low

  * The "Third time's the charm?" release.
  * Patch grt.h to work around #617748 (the root cause of #617395) by
    defining GC_FREEBSD_THREADS or GC_GNU_THREADS in addition to
    GC_THREADS as appropriate, as gc_config_macros.h does not yet do so.
  * Run (dh_auto_)configure --with-threads on all architectures again, as
    it should now really be safe to do so.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 10 Mar 2011 22:43:16 -0500

goo (0.155-9) unstable; urgency=low

  * Don't run (dh_auto_)configure --with-threads on kFreeBSD, on which
    libgc still lacks pthread support.  (Advancing to version 7 only made
    a difference on the Hurd.)  (Closes: #617395.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 08 Mar 2011 18:58:42 -0500

goo (0.155-8) unstable; urgency=low



=== debian/control ===
Source: goo
Maintainer: Aaron M. Ucko <ucko@debian.org>
Section: lisp
Priority: optional
Build-Depends: debhelper (>= 11~),
Build-Depends-Arch: libgc-dev,
                    libgmp10-dev | libgmp-dev
Build-Depends-Indep: dh-elpa
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/ucko/goo
Vcs-Git: https://salsa.debian.org/ucko/goo.git
Homepage: https://people.csail.mit.edu/jrb/goo/
Rules-Requires-Root: no

Package: goo
Architecture: any
Depends: emacsen-common (>= 2.0.8),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: elpa-goo,
          gcc,
          libgc-dev
Description: generic object-orientator (programming language)
 GOO is a dynamic, type-based, object-oriented language in the same family
 as Dylan and Scheme.  It is designed to be simple, productive, powerful,
 extensible, dynamic, efficient, and real-time.
 .
 Its main goal is to offer the best of both scripting and delivery
 languages, while at the same time incorporating an extreme back-to-basics
 philosophy.
 .
 This package contains the GOO interpreter and compiler, and
 documentation for the language and these programs.

Package: elpa-goo
Architecture: all
Depends: ${elpa:Depends},
         ${misc:Depends}
Recommends: emacs,
            goo
Enhances: emacs
Description: generic object-orientator (Emacs support)
 GOO is a dynamic, type-based, object-oriented language in the same family
 as Dylan and Scheme.  It is designed to be simple, productive, powerful,
 extensible, dynamic, efficient, and real-time.
 .
 Its main goal is to offer the best of both scripting and delivery
 languages, while at the same time incorporating an extreme back-to-basics
 philosophy.
 .
 This package contains an Emacs mode for editing GOO source and an
 interface for running the GOO interpreter directly from Emacs.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

CFLAGS  := $(shell dpkg-buildflags --get CFLAGS) -Wall \
           $(shell dpkg-buildflags --get CPPFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

## Suppress some warnings that mostly just lead to noise.
#CFLAGS += -Wno-sequence-point -Wno-pointer-sign -Wno-unused

ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),hppa)
    CFLAGS += -ffunction-sections
endif

export CFLAGS LDFLAGS

%:
	dh $@ --without autoreconf

binary binary-indep:
	dh $@ --with elpa --without autoreconf

override_dh_auto_configure-indep:;
override_dh_auto_configure-arch:
	dh_auto_configure -- --with-threads

override_dh_auto_build-indep:;
override_dh_auto_build-arch:
# We need to be strict about requiring prototypes because many functions
# return pointers, and their results may otherwise be misinterpreted on
# 64-bit systems.  However, this flag inconveniently manages to make a
# couple of configure's tests report false negatives, so we should pass it
# only when actually building.
	dh_auto_build -- CFLAGS="$(CFLAGS) -Werror-implicit-function-declaration"

override_dh_auto_install-indep:;
override_dh_auto_install-arch:
# No support for DESTDIR yet :-/
	dh_auto_install -- prefix=$(CURDIR)/debian/goo/usr
	mv debian/goo/usr/bin/goo debian/goo/usr/bin/g2c
	install debian/goo.sh debian/goo/usr/bin/goo

override_dh_installdocs:
	dh_installdocs -XCVS -Xgooomanual
	for p in `dh_listpackages`; do \
	    install -m 644 txt/changes.txt debian/$$p/usr/share/doc/$$p/NEWS; \
	done

# Work around libdebian-source-perl bug #919964 (lack of B-D-Arch support).
override_dh_elpa_test:;

## goo 0.155%2Bds

=== debian/changelog ===
goo (0.155+ds-5) unstable; urgency=medium

  * configure: Don't rely on implicit int, fixing GCC 14 builds.
    (Closes: #1075033.)
  * debian/goo.maintscript: Remove; it only covered upgrades from ancient
    versions (routine-update).
  * Standards-Version: 4.7.0 (routine-update)
  * Implicitly built against dh-elpa 2.1.3.

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 24 Jul 2024 20:15:20 -0400

goo (0.155+ds-4) unstable; urgency=medium

  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Add salsa-ci file (routine-update)
  * Trim trailing whitespace.
  * watch file standard 4 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 06 Feb 2021 23:23:20 -0500

goo (0.155+ds-3) unstable; urgency=medium

  * c/grt.h: Avoid an undefined symbol error under Clang 9 by defining
    INLINE to extern inline in the context of grt.c (and a C99+ compiler,
    but that should be a given nowadays).
  * debian/compat: Advance to 13 (from 11).
  * debian/control: Advance debhelper requirement to >= 13 accordingly.
  * debian/source.lintian-overrides: Remove, obsoleted by repacking.

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 02 Jun 2020 21:05:14 -0400

goo (0.155+ds-2) unstable; urgency=medium

  * c/grt.c: Comment out the definition of _DYNAMIC; it appears to be
    superfluous, and builds with GCC 10 otherwise fail with "multiple
    definition of `_DYNAMIC'".  Curiously, this GCC version attributes the
    previous definition to the .dynamic section of .../Scrt1.o, which
    comes from libcN-dev and when directly inspected contains no _DYNAMIC
    symbol or .dynamic section at all.  (Closes: #957300.)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 25 Apr 2020 21:17:51 -0400

goo (0.155+ds-1) unstable; urgency=medium

  [ Helmut Grohne ]
  * Fix FTCBFS: Export CC and friends for old ./configure. (Closes: #947650.)

  [ Aaron M. Ucko ]
  * Belatedly repack without nuisance (but free) content: old CVS metadata,
    an old core Cygwin DLL, and misnamed pregenerated HTML.
  * debian/control:
    - Remove vestigial goo -> emacsen-common dependency.
    - Standards-Version: 4.5.0 (already compliant).
  * debian/copyright:
    - Supply a proper structured (format 1.0) header.
    - Move primary (Files: *) paragraph to top.
    - Extend debian/* copyright to 2020.
    - Add a missing paragraph separator.
    - Add an inline description for the one LGPL-2+ paragraph.
    - Consolidate and expand GPL-2+ description in a standalone paragraph.
    - Add Files-Excluded: to match repacking.
  * debian/rules:
    - Omit dh_installdocs -X flags, superseded by repacking.  (Keep
      override_dh_installdocs for txt/changes.txt -> NEWS installation.)
    - Take advantage of buildflags.mk (inspired by Helmut's patch).
  * debian/watch: Reflect addition of +ds tag from repacking.

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 26 Jan 2020 21:26:07 -0500

## goo 0.155+ds

=== debian/changelog ===
goo (0.155+ds-6) unstable; urgency=medium

  * **/time/threads.{c,goo}: Don't pass %thread-goo-thread an explicit
    thread ID for which it has no use; per C23, GCC 15 interprets its
    signature as accepting no arguments, not an unspecified number.
    (Closes: #1096753.)
  * c/g2c/time/%threads.c: Shield thread metadata from possible premature
    garbage collection.  Its only baseline references had been from
    thread-local storage, which is off the GC's radar (and would remain so
    even if Goo were to switch from toolchain-managed TLS to
    pthread_{get,set}specific).
  * Standards-Version: 4.7.2 (routine-update)

 -- Aaron M. Ucko <ucko@debian.org>  Sat, 03 May 2025 21:37:48 -0400

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Maintainer: Aaron M. Ucko <ucko@debian.org>
 Section: lisp
 Priority: optional
-Build-Depends: debhelper (>= 11~),
+Build-Depends: debhelper-compat (= 13),
 Build-Depends-Arch: libgc-dev,
                     libgmp10-dev | libgmp-dev
 Build-Depends-Indep: dh-elpa
-Standards-Version: 4.3.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/ucko/goo
 Vcs-Git: https://salsa.debian.org/ucko/goo.git
 Homepage: https://people.csail.mit.edu/jrb/goo/
@@ -14,8 +14,7 @@
 
 Package: goo
 Architecture: any
-Depends: emacsen-common (>= 2.0.8),
-         ${misc:Depends},
+Depends: ${misc:Depends},
          ${shlibs:Depends}
 Suggests: elpa-goo,
           gcc,

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,11 @@
 #!/usr/bin/make -f
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+DPKG_EXPORT_BUILDTOOLS=1
+include /usr/share/dpkg/buildflags.mk
+-include /usr/share/dpkg/buildtools.mk
 
-CFLAGS  := $(shell dpkg-buildflags --get CFLAGS) -Wall \
-           $(shell dpkg-buildflags --get CPPFLAGS)
-LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)
+CFLAGS += -Wall $(CPPFLAGS)
 
 ## Suppress some warnings that mostly just lead to noise.
 #CFLAGS += -Wno-sequence-point -Wno-pointer-sign -Wno-unused
@@ -42,7 +43,7 @@
 	install debian/goo.sh debian/goo/usr/bin/goo
 
 override_dh_installdocs:
-	dh_installdocs -XCVS -Xgooomanual
+	dh_installdocs
 	for p in `dh_listpackages`; do \
 	    install -m 644 txt/changes.txt debian/$$p/usr/share/doc/$$p/NEWS; \
 	done

=== debian/watch ===
version=4
opts="dversionmangle=s/\+ds//,repacksuffix=+ds,uversionmangle=s/_/./g" \
    http://people.csail.mit.edu/jrb/goo/goo-(.*)-any-dev.tar.gz
